=== otherbackends/CMakeLists.txt ===
add_sources_from_current_dir(otherbackends
  raw.c
  rlogin.c
  supdup.c
  telnet.c
  testback.c)
