=== debian/changelog ===
putty (0.83-2) unstable; urgency=medium

  * Build enable_dit.c with -mbranch-protection=none.

 -- Colin Watson <cjwatson@debian.org>  Thu, 13 Feb 2025 13:00:34 +0000

putty (0.83-1) unstable; urgency=medium

  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Wed, 12 Feb 2025 13:01:56 +0000
