=== debian/control ===
Source: putty
Section: net
Priority: optional
Maintainer: Colin Watson <cjwatson@debian.org>
Standards-Version: 3.5.9
Build-Depends:
 cmake,
 debhelper (>= 13.1),
 debhelper-compat (= 13),
 dh-exec,
 dh-sequence-zz-debputy-rrr (>= 0.1.23~),
 dpkg-dev (>= 1.15.7~),
 python3 <!nocheck>,
Build-Depends-Arch:
 imagemagick,
 libgtk-3-dev,
 libx11-dev,
 pkgconf,
 python3:any,
 x11proto-core-dev,
Build-Depends-Indep:
 halibut,
Homepage: https://www.chiark.greenend.org.uk/~sgtatham/putty/
Vcs-Git: https://salsa.debian.org/ssh-team/putty.git
Vcs-Browser: https://salsa.debian.org/ssh-team/putty
Rules-Requires-Root: no
X-Style: black

Package: pterm
Section: x11
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 putty-doc,
Provides:
 x-terminal-emulator,
Multi-Arch: foreign
Description: PuTTY terminal emulator
 This is an X terminal emulator based on the popular Windows SSH client,
 PuTTY. It supports xterm escape sequences, plus some Linux console
 sequences for colour palette configuration and some DECterm sequences for
 title bar control, and with an appropriate font it supports the UTF-8
 encoding of Unicode. It also has some nifty features like rectangular
 selection and NetHack keypad mode.

Package: putty
Architecture: any
Depends:
 putty-tools,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 putty-doc,
Breaks:
 putty-tools (<< 0.68-2~),
Replaces:
 putty-tools (<< 0.68-2~),
Multi-Arch: foreign
Description: Telnet/SSH client for X
 This is the Unix port of the popular Windows SSH client, PuTTY. It supports
 flexible terminal setup, mid-session reconfiguration using Ctrl-rightclick,
 multiple X11 authentication protocols, and various other interesting things
 not provided by ssh in an xterm.
 .
 Pageant is an SSH authentication agent, and a tool for communicating with
 an already-running agent.

Package: putty-tools
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 putty-doc,
Multi-Arch: foreign
Description: command-line tools for SSH, SCP, and SFTP
 This package provides several command-line tools from the PuTTY suite that
 allow various kinds of secure interaction with remote systems.
 .
 Plink (PuTTY Link) connects to a remote system via SSH, Telnet, or rlogin,
 and either starts an interactive session or runs a batch process. It
 supports the usual SSH features like port forwarding, X11 forwarding,
 SOCKS, and compression.
 .
 PSCP (PuTTY Secure Copy) transfers files securely between systems using an
 SSH connection. It works with both SSH protocol 1 and protocol 2.
 .
 PSFTP (PuTTY SFTP client) transfers files securely between systems using
 the SSH file transfer protocol, which is specific to SSH protocol 2. In
 interactive mode its interface is much like the traditional Unix FTP
 client, although it can also operate in batch mode.
 .
 PuTTYgen generates SSH public and private key pairs in any of a number of
 formats, including those usable by PuTTY, OpenSSH, and ssh.com.
 .
 psusan (pseudo-SSH for untappable, separately authenticated networks) is a
 server program that behaves like the innermost "connection" layer of an SSH
 session, without the two outer security layers of encryption and
 authentication. It can be used to add SSH-like amenities to channels where
 you were already prepared to run a bare shell session.

Package: putty-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
Multi-Arch: foreign
Description: PuTTY HTML documentation
 Full HTML documentation for the PuTTY suite of programs (PuTTY, pterm,
 Plink, PSCP, PSFTP, and PuTTYgen).
